package Assignments.A4;

public class Mergesort {

    // Merges two subarrays of arr[].
    // First subarray is arr[l..m]
    // Second subarray is arr[m+1..r]
    void merge(int[] list, int left, int mid, int right) {

        // Create temp arrays
        int[] sub1 = new int[mid - left + 1];
        int[] sub2 = new int[right - mid];

        // Copy data to temp arrays
        System.arraycopy(list, left, sub1, 0, sub1.length);
        System.arraycopy(list, mid + 1, sub2, 0, sub2.length);

        int l1 = 0;
        int l2 = 0;

        // Initial index of merged subarray array
        int k = left;
        while (l1 < sub1.length && l2 < sub2.length) {
            if (sub1[l1] <= sub2[l2]) {
                list[k] = sub1[l1];
                l1++;
            } else {
                list[k] = sub2[l2];
                l2++;
            }
            k++;
        }

        // Copy remaining elements of L[] if any
        while (l1 < sub1.length) {
            list[k] = sub1[l1];
            l1++;
            k++;
        }

        // Copy remaining elements of R[] if any
        while (l2 < sub2.length) {
            list[k] = sub2[l2];
            l2++;
            k++;
        }
    }

    // Main function that sorts arr[l..r] using
    // merge()
    void sort(int[] list, int left, int right) {
        if (left < right) {

            // Find the middle point
            int m = left + (right - left) / 2;

            // Sort first and second halves
            sort(list, left, m);
            sort(list, m + 1, right);

            // Merge the sorted halves
            merge(list, left, m, right);
        }
    }

    // A utility function to print array of size n
    static void printArray(int[] list) {
        int n = list.length;
        for (int i = 0; i < n; ++i)
            System.out.print(list[i] + " ");
        System.out.println();
    }

    // Driver code
    public static void main(String[] args) {
        int[] arr = {12, 11, 13, 5, 6, 7};

        System.out.println("Given array is");
        printArray(arr);

        Mergesort ob = new Mergesort();
        ob.sort(arr, 0, arr.length - 1);

        System.out.println("\nSorted array is");
        printArray(arr);
    }
}
